void LOGGER_init__(LOGGER *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->MSG,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->LEVEL,LOGLEVEL__INFO,retain)
  __INIT_VAR(data__->TRIG0,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void LOGGER_body__(LOGGER *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  if ((__GET_VAR(data__->TRIG,) && !(__GET_VAR(data__->TRIG0,)))) {
    #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
    #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)

   LogMessage(GetFbVar(LEVEL),(char*)GetFbVar(MSG, .body),GetFbVar(MSG, .len));
  
    #undef GetFbVar
    #undef SetFbVar
;
  };
  __SET_VAR(data__->,TRIG0,,__GET_VAR(data__->TRIG,));

  goto __end;

__end:
  return;
} // LOGGER_body__() 





void PYTHON_EVAL_init__(PYTHON_EVAL *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CODE,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->ACK,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->RESULT,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->STATE,0,retain)
  __INIT_VAR(data__->BUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->PREBUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->TRIGM1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->TRIGGED,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PYTHON_EVAL_body__(PYTHON_EVAL *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  __IL_DEFVAR_T __IL_DEFVAR;
  __IL_DEFVAR_T __IL_DEFVAR_BACK;
  #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
  #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)
extern void __PythonEvalFB(int, PYTHON_EVAL*);__PythonEvalFB(0, data__);
  #undef GetFbVar
  #undef SetFbVar
;

  goto __end;

__end:
  return;
} // PYTHON_EVAL_body__() 





void PYTHON_POLL_init__(PYTHON_POLL *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CODE,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->ACK,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->RESULT,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->STATE,0,retain)
  __INIT_VAR(data__->BUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->PREBUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->TRIGM1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->TRIGGED,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PYTHON_POLL_body__(PYTHON_POLL *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  __IL_DEFVAR_T __IL_DEFVAR;
  __IL_DEFVAR_T __IL_DEFVAR_BACK;
  #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
  #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)
extern void __PythonEvalFB(int, PYTHON_EVAL*);__PythonEvalFB(1,(PYTHON_EVAL*)(void*)data__);
  #undef GetFbVar
  #undef SetFbVar
;

  goto __end;

__end:
  return;
} // PYTHON_POLL_body__() 





void PYTHON_GEAR_init__(PYTHON_GEAR *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->N,0,retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CODE,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->ACK,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->RESULT,__STRING_LITERAL(0,""),retain)
  PYTHON_EVAL_init__(&data__->PY_EVAL,retain);
  __INIT_VAR(data__->COUNTER,0,retain)
  __INIT_VAR(data__->ADD10_OUT,0,retain)
  __INIT_VAR(data__->EQ13_OUT,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->SEL15_OUT,0,retain)
  __INIT_VAR(data__->AND7_OUT,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PYTHON_GEAR_body__(PYTHON_GEAR *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  __SET_VAR(data__->,ADD10_OUT,,ADD__UINT__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (UINT)__GET_VAR(data__->COUNTER,),
    (UINT)1));
  __SET_VAR(data__->,EQ13_OUT,,EQ__BOOL__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (UINT)__GET_VAR(data__->N,),
    (UINT)__GET_VAR(data__->ADD10_OUT,)));
  __SET_VAR(data__->,SEL15_OUT,,SEL__UINT__BOOL__UINT__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (BOOL)__GET_VAR(data__->EQ13_OUT,),
    (UINT)__GET_VAR(data__->ADD10_OUT,),
    (UINT)0));
  __SET_VAR(data__->,COUNTER,,__GET_VAR(data__->SEL15_OUT,));
  __SET_VAR(data__->,AND7_OUT,,AND__BOOL__BOOL(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (BOOL)__GET_VAR(data__->EQ13_OUT,),
    (BOOL)__GET_VAR(data__->TRIG,)));
  __SET_VAR(data__->PY_EVAL.,TRIG,,__GET_VAR(data__->AND7_OUT,));
  __SET_VAR(data__->PY_EVAL.,CODE,,__GET_VAR(data__->CODE,));
  PYTHON_EVAL_body__(&data__->PY_EVAL);
  __SET_VAR(data__->,ACK,,__GET_VAR(data__->PY_EVAL.ACK,));
  __SET_VAR(data__->,RESULT,,__GET_VAR(data__->PY_EVAL.RESULT,));

  goto __end;

__end:
  return;
} // PYTHON_GEAR_body__() 





void PROGRAM0_init__(PROGRAM0 *data__, BOOL retain) {
  __INIT_VAR(data__->LSL_010,0,retain)
  __INIT_VAR(data__->LSL_010_ED,0,retain)
  __INIT_VAR(data__->LSH_010,0,retain)
  __INIT_VAR(data__->LSH_010_ED,0,retain)
  __INIT_VAR(data__->LSL_040,0,retain)
  __INIT_VAR(data__->LSL_040_ED,0,retain)
  __INIT_VAR(data__->LSH_040,0,retain)
  __INIT_VAR(data__->LSH_040_ED,0,retain)
  __INIT_VAR(data__->AGA_ONOFF,1,retain)
  __INIT_VAR(data__->AGA_ONOFF_SD,1,retain)
  __INIT_VAR(data__->AGL_ONOFF,1,retain)
  __INIT_VAR(data__->AGL_ONOFF_SD,1,retain)
  __INIT_VAR(data__->BCA_ONOFF,1,retain)
  __INIT_VAR(data__->BCA_ONOFF_SD,1,retain)
  __INIT_VAR(data__->LT_010,6.0,retain)
  __INIT_VAR(data__->LT_010_EA,39321,retain)
  __INIT_VAR(data__->TT_020A,40.0,retain)
  __INIT_VAR(data__->TT_020A_EA,26214,retain)
  __INIT_VAR(data__->TT_020B,46.35,retain)
  __INIT_VAR(data__->TT_020B_EA,30375,retain)
  __INIT_VAR(data__->FT_030,50.09,retain)
  __INIT_VAR(data__->FT_30_EA,8207,retain)
  __INIT_VAR(data__->LT_040,3.5,retain)
  __INIT_VAR(data__->LT_40_EA,45874,retain)
  __INIT_VAR(data__->TT_050A,80.0,retain)
  __INIT_VAR(data__->TT_050A_EA,52428,retain)
  __INIT_VAR(data__->TT_050B,82.85,retain)
  __INIT_VAR(data__->TT_050B_EA,54295,retain)
  __INIT_VAR(data__->TT_050C,70.0,retain)
  __INIT_VAR(data__->TT_050C_EA,45874,retain)
  __INIT_VAR(data__->FT_060,50.0,retain)
  __INIT_VAR(data__->FT_060_EA,8192,retain)
  __INIT_VAR(data__->TT_070,20.0,retain)
  __INIT_VAR(data__->TT_070_EA,13107,retain)
  __INIT_VAR(data__->PT_080,0.10,retain)
  __INIT_VAR(data__->PT_080_EA,6553,retain)
  __INIT_VAR(data__->FT_090,130.4,retain)
  __INIT_VAR(data__->FT_090_EA,28485,retain)
  __INIT_VAR(data__->AQC_POT,80.0,retain)
  __INIT_VAR(data__->AQC_POT_SA,52428,retain)
  __INIT_VAR(data__->BCA_VEL,50.0,retain)
  __INIT_VAR(data__->BCA_VEL_SA,32767,retain)
  __INIT_VAR(data__->VAL_POS,50.0,retain)
  __INIT_VAR(data__->VAL_POS_SA,32767,retain)
  __INIT_VAR(data__->MOVE47_OUT,0,retain)
  __INIT_VAR(data__->MOVE50_OUT,0,retain)
  __INIT_VAR(data__->MOVE53_OUT,0,retain)
  __INIT_VAR(data__->UINT_TO_REAL30_OUT,0,retain)
  __INIT_VAR(data__->SUB31_OUT,0,retain)
  __INIT_VAR(data__->DIV33_OUT,0,retain)
  __INIT_VAR(data__->MOVE3_OUT,0,retain)
  __INIT_VAR(data__->UINT_TO_REAL9_OUT,0,retain)
  __INIT_VAR(data__->SUB10_OUT,0,retain)
  __INIT_VAR(data__->DIV18_OUT,0,retain)
  __INIT_VAR(data__->MOVE8_OUT,0,retain)
}

// Code part
void PROGRAM0_body__(PROGRAM0 *data__) {
  // Initialise TEMP variables

  __SET_VAR(data__->,AGA_ONOFF_SD,,__BOOL_LITERAL(TRUE));
  __SET_VAR(data__->,AGL_ONOFF_SD,,__BOOL_LITERAL(TRUE));
  __SET_VAR(data__->,BCA_ONOFF_SD,,__BOOL_LITERAL(TRUE));
  __SET_VAR(data__->,MOVE47_OUT,,MOVE__UINT__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)52428));
  __SET_VAR(data__->,AQC_POT_SA,,__GET_VAR(data__->MOVE47_OUT,));
  __SET_VAR(data__->,MOVE50_OUT,,MOVE__UINT__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)32767));
  __SET_VAR(data__->,BCA_VEL_SA,,__GET_VAR(data__->MOVE50_OUT,));
  __SET_VAR(data__->,MOVE53_OUT,,MOVE__UINT__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)32767));
  __SET_VAR(data__->,VAL_POS_SA,,__GET_VAR(data__->MOVE53_OUT,));
  __SET_VAR(data__->,LSH_010,,__GET_VAR(data__->LSH_010_ED,));
  __SET_VAR(data__->,AGA_ONOFF,,__GET_VAR(data__->AGA_ONOFF_SD,));
  __SET_VAR(data__->,UINT_TO_REAL30_OUT,,UINT_TO_REAL(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)__GET_VAR(data__->LT_010_EA,)));
  __SET_VAR(data__->,SUB31_OUT,,SUB__REAL__REAL__REAL(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (REAL)__GET_VAR(data__->UINT_TO_REAL30_OUT,),
    (REAL)0.0));
  __SET_VAR(data__->,DIV33_OUT,,DIV__REAL__REAL__REAL(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (REAL)__GET_VAR(data__->SUB31_OUT,),
    (REAL)6553.5));
  __SET_VAR(data__->,MOVE3_OUT,,MOVE__REAL__REAL(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (REAL)__GET_VAR(data__->DIV33_OUT,)));
  __SET_VAR(data__->,LT_010,,__GET_VAR(data__->MOVE3_OUT,));
  __SET_VAR(data__->,UINT_TO_REAL9_OUT,,UINT_TO_REAL(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)__GET_VAR(data__->AQC_POT_SA,)));
  __SET_VAR(data__->,SUB10_OUT,,SUB__REAL__REAL__REAL(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (REAL)__GET_VAR(data__->UINT_TO_REAL9_OUT,),
    (REAL)0.0));
  __SET_VAR(data__->,DIV18_OUT,,DIV__REAL__REAL__REAL(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (REAL)__GET_VAR(data__->SUB10_OUT,),
    (REAL)655.35));
  __SET_VAR(data__->,MOVE8_OUT,,MOVE__REAL__REAL(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (REAL)__GET_VAR(data__->DIV18_OUT,)));
  __SET_VAR(data__->,AQC_POT,,__GET_VAR(data__->MOVE8_OUT,));

  goto __end;

__end:
  return;
} // PROGRAM0_body__() 





